## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##
## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##
##
## PermaSense GPS Data Export & Anlysis Tool
##
## This allows access PermaSense Differential GPS Batch Daily data
## - Data is imported from GSN DB server, plotted
## - Missing data is linearly interpolated, plotted
## - Annual mean horizontal surface velocitiess are calculated
## - A CSV data file is generated
##
## @author: Samuel Weber, Jan Beutel
## @date:   January 07, 2020
## @version v1.5
##
## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##
## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

##====================================================================
## PREPARATION

require(zoo)
require(xts)
require(lubridate)
require(lattice)
require(gridExtra)
require(grid)

#setwd("~/permasense_engineering/software/gps/gps_permos_toolchain")

## construct method to concatenate strings with ampersand
"&" <- function(...) UseMethod("&") 
"&.default" <- .Primitive("&") 
"&.character" <- function(...) paste(...,sep="")

##=====================================================================
## DEFINE DIFFERENT VARIABLES (CHANGE TO YOUR NEEDS)

## set server
server <- "http://data.permasense.ch/"
  
## set virtual_sensor name
## BERNESE position solutions are *__batch_daily
## RTKLIB  position solutions are *__rtklib_daily

#virtual_sensor <- "dirruhorn_gps_differential__batch__daily"
#virtual_sensor <- "matterhorn_gps_differential__batch__daily"
#virtual_sensor <- "permos_gps_differential__batch__daily"
#virtual_sensor <- "saastal_gps_differential__batch__daily"

#RTKLIB_processing <- TRUE
#virtual_sensor <- "dirruhorn_gps_differential__rtklib__daily"
#virtual_sensor <- "matterhorn_gps_differential__rtklib__daily"
#virtual_sensor <- "permos_gps_differential__rtklib__daily"
#virtual_sensor <- "saastal_gps_differential__rtklib__daily"

#virtual_sensor_inclino <- "dirruhorn_gps_inclinometer"
#virtual_sensor_inclino <- "matterhorn_gps_inclinometer"
#virtual_sensor_inclino <- "permos_gps_inclinometer"

# DH positions 0, 5, 7, 15, 17, 86, 87
#         ST   29, 31
#         RD   6, 9, 70, 81
#         BH   12, 25, 27, 55, 62, 63
#         LS   64, 83, 84, 88
#         GG   41, 43, 44, 66, 67
#         WYS  82 
#         SA   89, 91
#         legacy LS, GU 21, 23, 33, 35
# MH positions: 33, 34, 35, 40, 42, 43
# PERMOS positions: 1-10 RIT1 = 3
# Saastal positions: 1, 2, 3, 5
#position = 5

## In der Schweiz ueblich ist der Zeitraum zwischen dem 1. Oktober und dem 30. September des folgenden Jahres als hydrologisches Jahr 
## time window
#date_beg <- "15/12/2010+00:00:00"
#date_beg <- "02/05/2011+00:00:00"
#date_beg <- "01/09/2018+00:00:00"
#MH40 begin
#date_beg <- "26/06/2015+00:00:00"
#date_end <- "11/10/2018+00:00:00"
#date_beg <- "01/06/2015+00:00:00"
#date_end <- strftime(Sys.Date(), format="%d/%m/%Y+%H:%M:%S")

##=====================================================================
## CREATING URL FOR GSN-REQUEST
## check document gsn-datadistribution-one-shot.pdf and data_access.rtf
## url<-"http://data.permasense.ch/multidata?vs[1]=dirruhorn_gps_raw__mapped&field[1]=gps_time,gps_week&from=09/02/2012+12:00:00&to=09/02/2012+13:00:00&timeline=generation_time&c_join[1]=and&c_vs[1]=dirruhorn_gps_raw__mapped&c_field[1]=position&c_min[1]=38&c_max[1]=39"

## selection by time intervall, position ordered by generation_time
query <- "vs[1]=" & virtual_sensor & "&time_format=unix&field[1]=All&from=" & date_beg & "&to=" & date_end & "&c_join[1]=and&c_vs[1]=" & virtual_sensor & "&c_field[1]=position&c_min[1]=" & position-1 & "&c_max[1]=" & position & "&timeline=generation_time"

## construct url:
url <- server & "multidata?" & query 
#print("http request is: "&url)

##=====================================================================
## ACCESS TO GSN DATABASE
## accessing data and making of data frame (from csv export)
## skip header lines (first 2) for import
dat <- read.csv(url, skip=2, stringsAsFactors=FALSE)

#fix first column naming
names(dat)[1]<-paste("position")
#extract label
label <- as.character(dat$label[1])

##=====================================================================
## Convert timestamps to UTC
dat$generation_time <- as.POSIXct(dat$generation_time/1000, origin="1970-01-01", format="%Y-%m-%d", tz="UTC")
dat$processing_time <- as.POSIXct(as.numeric(dat$processing_time)/1000, origin="1970-01-01", format="%Y-%m-%d", tz="UTC")

# reorder some columns
refcols <- c("position", "label", "generation_time", "device_id", "device_type", "version", "reference_label", "processing_time")
dat <- dat[, c(refcols, setdiff(names(dat), refcols))]
names(dat)

##=====================================================================
## Correct for moving reference position, e.g. on Matterhorn Hoernligrat
if (dat$reference_label[1] == "HOGR"){

  if (max(dat$generation_time) > max(gps_data_HOGR$generation_time)) {
    dat <- dat[-c(1), ]
  }
  
  correction_min_date = min(dat$generation_time)
  correction_max_date = max(dat$generation_time)
  correction_min_index = match(correction_min_date, dat$generation_time)
  correction_max_index = match(correction_max_date, dat$generation_time)

  correction_date <- correction_max_date
  correction_index = match(correction_date, dat$generation_time)

  correction_min_index_HOGR = match(correction_min_date, gps_data_HOGR$generation_time)
  correction_max_index_HOGR = match(correction_max_date, gps_data_HOGR$generation_time)
  correction_index_HOGR = match(correction_date, gps_data_HOGR$generation_time)

  correction_mh_count <- length(grep( "ZERM", dat$reference_label))
  if (correction_mh_count > 0){
    correction_mh_start <- min(grep( "ZERM", dat$reference_label))
    correction_mh_end <- max(grep( "ZERM", dat$reference_label))
  }else{
    correction_mh_start <- 1
    correction_mh_end <- 1
  }
  correction_mh_ZERM_mean_e <- mean(dat$e[grep( "ZERM", dat$reference_label)], na.rm=TRUE)
  correction_mh_HOGR_mean_e <- mean(dat$e[c((correction_mh_end+1):(correction_mh_end+10))], na.rm=TRUE)
  correction_mh_ZERM_mean_n <- mean(dat$n[grep( "ZERM", dat$reference_label)], na.rm=TRUE)
  correction_mh_HOGR_mean_n <- mean(dat$n[c((correction_mh_end+1):(correction_mh_end+10))], na.rm=TRUE)
  correction_mh_ZERM_mean_h <- mean(dat$h[grep( "ZERM", dat$reference_label)], na.rm=TRUE)
  correction_mh_HOGR_mean_h <- mean(dat$h[c((correction_mh_end+1):(correction_mh_end+10))], na.rm=TRUE)
  
    while (correction_index <= correction_min_index){

    if (dat$reference_label[correction_index] == "HOGR"){
      dat$e[correction_index] <- dat$e[correction_index] - (gps_data_HOGR$e[correction_max_index_HOGR] - gps_data_HOGR$e[correction_index_HOGR])
      dat$n[correction_index] <- dat$n[correction_index] - (gps_data_HOGR$n[correction_max_index_HOGR] - gps_data_HOGR$n[correction_index_HOGR])
      dat$h[correction_index] <- dat$h[correction_index] - (gps_data_HOGR$h[correction_max_index_HOGR] - gps_data_HOGR$h[correction_index_HOGR])
    }
      
    ## Correction for missing HOGR observables
    if (dat$reference_label[correction_index] == "ZERM"){
      #> gps_data_MH34$e[53] - gps_data_MH34$e[55]
      #[1] 0.1559
      #> gps_data_MH34$n[53] - gps_data_MH34$n[55]
      #[1] -0.0672
      #> gps_data_MH34$h[53] - gps_data_MH34$h[55]
      #[1] -0.0396
      dat$e[correction_index] <- dat$e[correction_index] - (correction_mh_ZERM_mean_e - correction_mh_HOGR_mean_e + 0.026)
      dat$n[correction_index] <- dat$n[correction_index] - (correction_mh_ZERM_mean_n - correction_mh_HOGR_mean_n - 0.005)
      dat$h[correction_index] <- dat$h[correction_index] - (correction_mh_ZERM_mean_h - correction_mh_HOGR_mean_h - 0.01)
    }

    correction_index <- correction_index + 1
    correction_index_HOGR = match(dat$generation_time[correction_index], gps_data_HOGR$generation_time)
    
  }
}

#export to R variables
assign("gps_data_"&label, dat)


##=====================================================================
## PLOT PROCESSING STATUS
plot_title <- as.character(label&" - Position "&position&" - "&as.Date(min(dat$generation_time))&" to "&as.Date(max(dat$generation_time)))

par(mfrow=c(1,1))
plot(x=dat$generation_time, y=round((as.numeric(dat$generation_time)-as.numeric(dat$processing_time))/(3600*24)), xlab="", ylab="Processing lag [days]", main=plot_title, ylim=c(min(round((as.numeric(dat$generation_time)-as.numeric(dat$processing_time))/(3600*24)), na.rm = TRUE),0))
abline(h=-30)

#print plot to pdf
plot_name <- "gps_"&label&"_processing_status.pdf"
dev.copy(pdf,plot_name, width=21/2.54, height=29.7/2.54)
dev.off()


##=====================================================================
## PLOT DATA OVERVIEW
##
#windows(width=21/2.54, height=29.7/2.54)
par(mfrow=c(5,3), mar=c(2,4,3,1), oma=c(2,1,4,1)) #bottom, left, top, right
#par(mfrow=c(3,1), oma=c(0,0,3,0))
plot(dat$generation_time,dat$e,type="p", col="blue", cex=0.2, main="Displacement East", ylab="East", xlab="")
plot(dat$generation_time,dat$n,type="p", col="blue", cex=0.2, main="Displacement North", ylab="North", xlab="")
plot(dat$generation_time,dat$h,type="p", col="blue", cex=0.2, main="Displacement Altitude", ylab="Altitude [m]", xlab="")
mtext(plot_title, outer = TRUE, cex = 1.5)

# interpolate missing position values
data_temp <- zoo(dat$e,dat$generation_time)
data_e <- na.approx(object=data_temp, 
                   xout=seq(min(dat$generation_time), max(dat$generation_time), "day"))
data_temp <- zoo(dat$n,dat$generation_time)
data_n <- na.approx(object=data_temp, 
                    xout=seq(min(dat$generation_time), max(dat$generation_time), "day"))
data_temp <- zoo(dat$h,dat$generation_time)
data_h <- na.approx(object=data_temp, 
                    xout=seq(min(dat$generation_time), max(dat$generation_time), "day"))

plot(data_e, type="p", cex=0.2, ylab="East", xlab="")
plot(data_n, type="p", cex=0.2, ylab="North", xlab="", main="Linear interpolation of missing positions")
plot(data_h, type="p", cex=0.2, ylab="Altitude [m]", xlab="")

# negate differences for correct volocity orientation
plot(as.zoo(diff.xts(-data_e, lag=30)), type="p", cex=0.2, ylab="East", xlab="")
plot(as.zoo(diff.xts(-data_n, lag=30)), type="p", cex=0.2, ylab="North", xlab="", main="Displacement diff. 30d running mean")
plot(as.zoo(diff.xts(-data_h, lag=30)), type="p", cex=0.2, ylab="Altitude [m]", xlab="")

##=====================================================================
## Calculating annual displacement values [m/a]
avg_date_max <- max(index(data_e))
avg_date_max_string <- as.character(avg_date_max)
avg_date_max_year <- as.character(avg_date_max, tz="UTC", format="%Y")
if ((avg_date_max_year&"-10-01 12:00:00") > avg_date_max) {
  avg_current_year <- as.numeric(avg_date_max_year)
} else {
  avg_current_year <- as.numeric(avg_date_max_year) + 1
}

avg_date_min_string <- as.character(avg_current_year-1)&"-10-01 12:00:00"
avg_date_min <- as.POSIXct(avg_date_min_string, tz="UTC")

annual_displacements <- data.frame()

while (avg_date_min > min(index(data_e))) {
  # calculate displacement differences
  e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=4)
  n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=4)
  h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=4)
                                                                 
  horiz_displacement = round(sqrt(e_displacement^2 + n_displacement^2), digits=4)
  horiz_azimuth <- round(180/pi * atan2(e_displacement, n_displacement), digits=3)
  if (horiz_azimuth < 0) {
    horiz_azimuth <- horiz_azimuth + 360
  }
  vertical_displacement = round(h_displacement, digits=4)
  total_displacement = round(sqrt(e_displacement^2 + n_displacement^2 + h_displacement^2), digits=4)
  inclination = round(90 - (180/pi * acos(vertical_displacement/total_displacement)), digits=2)
  
  # avg cumulated velocity normalized for 1Y period
  avg_range <- as.character(avg_date_min_string&"/"&avg_date_max_string)
  data_temp <- xts(dat$v_horiz,dat$generation_time)
  avg_v_horiz <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
  data_temp <- xts(dat$v_h,dat$generation_time)
  avg_v_h <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
  data_temp <- xts(dat$v_3d,dat$generation_time)
  avg_v_3d <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)

  #avg_window_start_date_string <- as.character(avg_current_year)&"-10-01 12:00:00"
  avg_window_start_date_string <- as.character(avg_current_year)&"-10-01"
  avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
  measurement_interval <- as.character(as.Date(avg_date_min))&"::"&as.character(as.Date(avg_date_max))
  
  annual_displacements <- rbind(annual_displacements, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
  
  avg_current_year <- avg_current_year - 1
  avg_date_max_string <- as.character(avg_current_year)&"-09-30 12:00:00"
  avg_date_max <- as.POSIXct(avg_date_max_string, tz="UTC")
  avg_date_min_string <- as.character(avg_current_year-1)&"-10-01 12:00:00"
  avg_date_min <- as.POSIXct(avg_date_min_string, tz="UTC")
  
}

# do it again for first year
avg_date_min <- avg_date_min <- min(index(data_e))
avg_date_min_string <- as.character(avg_date_min)

# calculate displacement differences
e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=3)
n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=3)
h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=3)
                                                                                                                                                                                             
horiz_displacement = round(sqrt(e_displacement^2 + n_displacement^2), digits=3)
horiz_azimuth <- round(180/pi * atan2(e_displacement, n_displacement), digits=2)
if (horiz_azimuth < 0) {
  horiz_azimuth <- horiz_azimuth + 360
}
vertical_displacement = round(h_displacement, digits=3)
total_displacement = round(sqrt(e_displacement^2 + n_displacement^2 + h_displacement^2), digits=3)
inclination = round(90 - (180/pi *acos(vertical_displacement/total_displacement)), digits=2)

# avg cumulated velocity normalized for 1Y period
avg_range <- as.character(avg_date_min_string&"/"&avg_date_max_string)
data_temp <- xts(dat$v_horiz,dat$generation_time)
avg_v_horiz <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
data_temp <- xts(dat$v_h,dat$generation_time)
avg_v_h <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
data_temp <- xts(dat$v_3d,dat$generation_time)
avg_v_3d <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)

avg_window_start_date_string <- as.character(avg_current_year)&"-10-01"
avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
measurement_interval <- as.character(as.Date(avg_date_min))&"::"&as.character(as.Date(avg_date_max))

annual_displacements <- rbind(annual_displacements, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))


##################################################################################################
## Calculating monthly displacement values [m/a]
##################################################################################################
avg_date_max <- max(index(data_e))
avg_date_max_string <- as.character(avg_date_max)
avg_date_max_year <- as.character(avg_date_max, tz="UTC", format="%Y")
avg_date_max_month <- as.character(avg_date_max, tz="UTC", format="%m")

avg_current_year <- as.numeric(avg_date_max_year)
avg_current_month <- as.numeric(avg_date_max_month)

avg_date_min_string <- as.character(avg_current_year)&"-"&as.character(sprintf("%02d", avg_current_month))&"-01 12:00:00"
avg_date_min <- as.POSIXct(avg_date_min_string, tz="UTC")
#avg_date_max_string <- as.character(avg_current_year)&"-"&as.character(sprintf("%02d", avg_current_month))&"-01 12:00:00"
#avg_date_min <- as.POSIXct(avg_date_min_string, tz="UTC")

monthly_displacements <- data.frame()

while (avg_date_min > min(index(data_e))) {
  # calculate displacement differences
  if (length(rollapply(data_e, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_e, width=60, mean)[avg_date_min]) > 0 ){
    e_displacement = round(as.numeric(rollapply(data_e, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_e, width=60, mean)[avg_date_min]), digits=4)
  } else {
    e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=4)
  }
  if (length(rollapply(data_n, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_n, width=60, mean)[avg_date_min]) > 0 ) {
    n_displacement = round(as.numeric(rollapply(data_n, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_n, width=60, mean)[avg_date_min]), digits=4)
  } else {
    n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=4)
  }
  if (length(rollapply(data_h, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_h, width=60, mean)[avg_date_min]) > 0 ) {
    h_displacement = round(as.numeric(rollapply(data_h, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_h, width=60, mean)[avg_date_min]), digits=4)
  } else {
    h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=4)
  }
      
  #e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=4)
  #n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=4)
  #h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=4)

  horiz_displacement = round(sqrt(e_displacement^2 + n_displacement^2), digits=4)
  horiz_azimuth <- round(180/pi * atan2(e_displacement, n_displacement), digits=3)
  if (horiz_azimuth < 0) {
    horiz_azimuth <- horiz_azimuth + 360
  }
  vertical_displacement = round(h_displacement, digits=4)
  total_displacement = round(sqrt(e_displacement^2 + n_displacement^2 + h_displacement^2), digits=4)
  inclination = round(90 - (180/pi * acos(vertical_displacement/total_displacement)), digits=2)

  # avg cumulated velocity normalized for 1month period
  avg_range <- as.character(avg_date_min_string&"/"&avg_date_max_string)
  data_temp <- xts(dat$v_horiz,dat$generation_time)
  avg_v_horiz <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
  data_temp <- xts(dat$v_h,dat$generation_time)
  avg_v_h <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
  data_temp <- xts(dat$v_3d,dat$generation_time)
  avg_v_3d <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)

  avg_window_start_date_string <- as.character(avg_current_year)&"-"&as.character(sprintf("%02d", avg_current_month))&"-01"
  avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
  measurement_interval <- as.character(as.Date(avg_date_min))&"::"&as.character(as.Date(avg_date_max))

  monthly_displacements <- rbind(monthly_displacements, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))

  avg_date_max <- avg_date_min-(3600*24)
  avg_date_max_string <- as.character(avg_date_max)
  avg_date_max_year <- as.character(avg_date_max, tz="UTC", format="%Y")
  avg_date_max_month <- as.character(avg_date_max, tz="UTC", format="%m")
  avg_current_year <- as.numeric(avg_date_max_year)
  avg_current_month <- as.numeric(avg_date_max_month)

  avg_date_min_string <- as.character(avg_current_year)&"-"&as.character(sprintf("%02d", avg_current_month))&"-01 12:00:00"
  avg_date_min <- as.POSIXct(avg_date_min_string, tz="UTC")
}

# do it again for last month
avg_date_min <- avg_date_min <- min(index(data_e))
avg_date_min_string <- as.character(avg_date_min)

# calculate displacement differences
if (length(rollapply(data_e, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_e, width=60, mean)[avg_date_min]) > 0 ){
  e_displacement = round(as.numeric(rollapply(data_e, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_e, width=60, mean)[avg_date_min]), digits=4)
} else {
  e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=4)
}
if (length(rollapply(data_n, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_n, width=60, mean)[avg_date_min]) > 0 ) {
  n_displacement = round(as.numeric(rollapply(data_n, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_n, width=60, mean)[avg_date_min]), digits=4)
} else {
  n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=4)
}
if (length(rollapply(data_h, width=60, mean)[avg_date_max]) > 0 && length(rollapply(data_h, width=60, mean)[avg_date_min]) > 0 ) {
  h_displacement = round(as.numeric(rollapply(data_h, width=60, mean)[avg_date_max]) - as.numeric(rollapply(data_h, width=60, mean)[avg_date_min]), digits=4)
} else {
  h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=4)
}

#e_displacement = round(as.numeric(data_e[avg_date_max]) - as.numeric(data_e[avg_date_min]), digits=4)
#n_displacement = round(as.numeric(data_n[avg_date_max]) - as.numeric(data_n[avg_date_min]), digits=4)
#h_displacement = round(as.numeric(data_h[avg_date_max]) - as.numeric(data_h[avg_date_min]), digits=4)

horiz_displacement = round(sqrt(e_displacement^2 + n_displacement^2), digits=4)
horiz_azimuth <- round(180/pi * atan2(e_displacement, n_displacement), digits=3)
if (horiz_azimuth < 0) {
  horiz_azimuth <- horiz_azimuth + 360
}
vertical_displacement = round(h_displacement, digits=4)
total_displacement = round(sqrt(e_displacement^2 + n_displacement^2 + h_displacement^2), digits=4)
inclination = round(90 - (180/pi * acos(vertical_displacement/total_displacement)), digits=2)

# avg cumulated velocity normalized for 1Y period
avg_range <- as.character(avg_date_min_string&"/"&avg_date_max_string)
data_temp <- xts(dat$v_horiz,dat$generation_time)
avg_v_horiz <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
data_temp <- xts(dat$v_h,dat$generation_time)
avg_v_h <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)
data_temp <- xts(dat$v_3d,dat$generation_time)
avg_v_3d <- round(mean(as.numeric(data_temp[avg_range]))*3.65, digits=3)

avg_window_start_date_string <- as.character(avg_current_year)&"-"&as.character(sprintf("%02d", avg_current_month))&"-01"
avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
measurement_interval <- as.character(as.Date(avg_date_min))&"::"&as.character(as.Date(avg_date_max))

monthly_displacements <- rbind(monthly_displacements, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))

assign("gps_monthly_displacements_"&label, monthly_displacements)

##=====================================================================
## Calculating key variables
##=====================================================================
measurement_duration  <- as.numeric(as.Date(max(dat$generation_time)) - as.Date(min(dat$generation_time)))
east_displacement     <- round(sum(annual_displacements$e_displacement), digits=3)
east_rate             <- round(east_displacement/(measurement_duration/365), digits=3)
north_displacement    <- round(sum(annual_displacements$n_displacement), digits=3)
north_rate            <- round(north_displacement/(measurement_duration/365), digits=3)
horiz_displacement    <- round(sum(annual_displacements$horiz_displacement), digits=3)
horiz_rate            <- round(horiz_displacement/(measurement_duration/365), digits=3)
vertical_displacement <- round(sum(annual_displacements$vertical_displacement), digits=3)
vertical_rate         <- round(vertical_displacement/(measurement_duration/365), digits=3)
total_displacement    <- round(sum(annual_displacements$total_displacement), digits=3)
total_rate            <- round(total_displacement/(measurement_duration/365), digits=3)

horiz_azimuth         <- round(mean(annual_displacements$horiz_azimuth), digits=2)
inclination           <- round(mean(annual_displacements$inclination), digits=2)

total_displacements <- data.frame()
total_displacements <- rbind(total_displacements, data.frame(measurement_duration, 
                                                             east_displacement, 
                                                             east_rate, 
                                                             north_displacement, 
                                                             north_rate, 
                                                             horiz_displacement, 
                                                             horiz_rate,vertical_displacement,
                                                             vertical_rate,total_displacement, 
                                                             total_rate, 
                                                             horiz_azimuth,
                                                             inclination))


##==================================================================
## Now plotting monthly velocities, annual displacements
##==================================================================
if (RTKLIB_processing) {
  plot(monthly_displacements$avg_window_start_date, monthly_displacements$horiz_displacement, type="s", main="Monthly horizontal displacement", ylab="[m/month]", xlab="")#, ylim=c(0,15))
  legend("bottomleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)

  plot(monthly_displacements$avg_window_start_date, monthly_displacements$vertical_displacement, type="s", main="Monthly vertical displacement", ylab="[m/month]", xlab="")#, ylim=c(-10,0))
  legend("topleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)

  plot(monthly_displacements$avg_window_start_date, monthly_displacements$total_displacement, type="s", main="Monthly 3D displacement", ylab="[m/month]", xlab="")#, ylim=c(0,15))
  legend("bottomleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)
  
  plot(annual_displacements$avg_window_start_date, annual_displacements$horiz_displacement, type="s", main="Annual horizontal displacement", ylab="[m/a]", xlab="")#, ylim=c(0,15))
  legend("bottomleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)
  
  plot(annual_displacements$avg_window_start_date, annual_displacements$vertical_displacement, type="s", main="Annual vertical displacement", ylab="[m/a]", xlab="")#, ylim=c(-10,0))
  legend("topleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)
  
  plot(annual_displacements$avg_window_start_date, annual_displacements$total_displacement, type="s", main="Annual 3D displacement", ylab="[m/a]", xlab="")#, ylim=c(0,15))
  legend("bottomleft", inset=0.05, legend=c("Displacement difference"), col=c("black"), lty=1, cex=0.6)
} else {
  #ylim_value <- c(-0.03,0.02)
  plot(dat$generation_time,dat$v_horiz,type="p", col="blue",cex=0.2, main="Horizontal daily velocity", ylab="[cm/d]", xlab="", ylim=c(-5,5))
  plot(dat$generation_time,dat$v_h,type="p", col="blue",cex=0.2, main="Vertical daily velocity", ylab="[cm/d]", xlab="", ylim=c(-5,5))
  plot(dat$generation_time,dat$v_3d,type="p", col="blue",cex=0.2, main="3D daily velocity", ylab="[cm/d]", xlab="", ylim=c(-5,5))

  plot(annual_displacements$avg_window_start_date, annual_displacements$horiz_displacement, type="s", main="Annual horizontal displacement", ylab="[m/a]", xlab="")#, ylim=c(0,15))
  lines(annual_displacements$avg_window_start_date, annual_displacements$avg_v_horiz, type="s", col="blue")
  legend("bottomleft", inset=0.05, legend=c("Displacement difference", "Mean velocity"), col=c("black", "blue"), lty=1, cex=0.6)
  
  plot(annual_displacements$avg_window_start_date, annual_displacements$vertical_displacement, type="s", main="Annual vertical displacement", ylab="[m/a]", xlab="")#, ylim=c(-10,0))
  lines(annual_displacements$avg_window_start_date, annual_displacements$avg_v_h, type="s", col="blue")
  legend("topleft", inset=0.05, legend=c("Displacement difference", "Mean velocity"), col=c("black", "blue"), lty=1, cex=0.6)
  
  plot(annual_displacements$avg_window_start_date, annual_displacements$total_displacement, type="s", main="Annual 3D displacement", ylab="[m/a]", xlab="")#, ylim=c(0,15))
  lines(annual_displacements$avg_window_start_date, annual_displacements$avg_v_3d, type="s", col="blue")
  legend("bottomleft", inset=0.05, legend=c("Displacement difference", "Mean velocity"), col=c("black", "blue"), lty=1, cex=0.6)
}

#print plot to pdf
plot_name <- "gps_"&label&"_plot_timeseries.pdf"
dev.copy(pdf,plot_name, width=21/2.54, height=29.7/2.54)
dev.off()

##=====================================================================
## Export data
##==================================================================

#export to R variables
assign("gps_data_"&label, dat)
assign("gps_annual_displacements_"&label, annual_displacements)
assign("gps_total_displacements_"&label, total_displacements)

# Export to CSV file
file_name <- "gps_"&label&"_data.csv"
file_header <- "Differential GPS Position Data File (c) ETH Zurich 2020 \n"
file_subheader <- plot_title&"\n\n"&
                  "Measurement period: "&as.Date(min(dat$generation_time))&" to "&as.Date(max(dat$generation_time))&"\n"&
                  "Measurement duration: "&measurement_duration&" days; "&round(measurement_duration/365, digits=2)&" years\n"&
                  "Total east displacement: "&east_displacement&" m\n"&
                  "Average east displacement rate: "&east_rate&" m/a\n"&
                  "Total north displacement: "&north_displacement&" m\n"&
                  "Average north displacement rate: "&north_rate&" m/a\n"&
                  "Total horizontal displacement: "&horiz_displacement&" m\n"&
                  "Average horizontal displacement rate: "&horiz_rate&" m/a\n"&
                  "Total vertical displacement: "&vertical_displacement&" m\n"&
                  "Average vertical displacement rate: "&vertical_rate&" m/a\n"&
                  "Total displacement: "&total_displacement&" m\n"&
                  "Average total displacement rate: "&total_rate&" m/a\n"&
                  "Azimuth of displacement: "&horiz_azimuth&" 0\n"&
                  "Inclination of displacement: "&inclination&" 0\n"
                  
cat(file_header, '\n', file = file_name)
cat(file_subheader,  '\n', file = file_name, append = TRUE)
cat("Annual displacements\n", '\n', file = file_name, append = TRUE)
suppressWarnings(write.table(annual_displacements, file = file_name, append = TRUE, quote = FALSE, sep=',', row.names = FALSE, col.names = TRUE))
cat("\nMonthly displacements\n", '\n', file = file_name, append = TRUE)
suppressWarnings(write.table(monthly_displacements, file = file_name, append = TRUE, quote = FALSE, sep=',', row.names = FALSE, col.names = TRUE))
cat("\nDaily positions are 12:00:00 UTC centered using the generation_time column\nGeodetic datum is CH1903+/LV95\nReference Frame Bessel (ellipsoidal)\n", '\n', file = file_name, append = TRUE)
suppressWarnings(write.table(dat, file = file_name, append = TRUE, quote = FALSE, sep=',', row.names = FALSE, col.names = TRUE))

write.table_with_header <- function(x, file, header, ...){
  cat(header, '\n',  file = file)
  write.table(x, file, append = TRUE, quote = FALSE, sep=',', row.names = FALSE, col.names = TRUE)
}


##==================================================================
## Calculating Levelplots for monthly displacements
##==================================================================
monthly_displacements2 <- data.frame()

avg_date_max_year  <- as.character(max(monthly_displacements$avg_window_start_date), tz="UTC", format="%Y")
avg_date_max_month <- as.character(max(monthly_displacements$avg_window_start_date), tz="UTC", format="%m")

lead_in_month <- 09

if (lead_in_month > as.numeric(avg_date_max_month)){
  lead_in_iterations <- 9 - as.numeric(avg_date_max_month)
  
  while (lead_in_iterations > 0) {
    avg_window_start_date_string <- avg_date_max_year&"-"&as.character(sprintf("%02d", lead_in_iterations+as.numeric(avg_date_max_month)))&"-01"
    avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
    avg_window_stop_date <- avg_window_start_date
    month(avg_window_stop_date) <- month(avg_window_stop_date) + 1
    day(avg_window_stop_date) <- day(avg_window_stop_date) -1
    measurement_interval <- avg_window_start_date_string&"::"&as.character(avg_window_stop_date)
    e_displacement = NA
    n_displacement = NA
    horiz_displacement = NA
    avg_v_horiz = NA
    vertical_displacement = NA
    avg_v_h = NA
    total_displacement = NA
    avg_v_3d = NA
    horiz_azimuth = NA
    inclination = NA
    
    monthly_displacements2 <- rbind(monthly_displacements2, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
    lead_in_iterations <- lead_in_iterations - 1
  }
} 

if (lead_in_month < as.numeric(avg_date_max_month)){
  lead_in_iterations <- 9
  avg_date_max_year <- as.character(as.numeric(avg_date_max_year)+1)
  
  while (lead_in_iterations > 0) {
    avg_window_start_date_string <- avg_date_max_year&"-"&as.character(sprintf("%02d", lead_in_iterations))&"-01"
    avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
    avg_window_stop_date <- avg_window_start_date
    month(avg_window_stop_date) <- month(avg_window_stop_date) + 1
    day(avg_window_stop_date) <- day(avg_window_stop_date) -1
    measurement_interval <- avg_window_start_date_string&"::"&as.character(avg_window_stop_date)
    e_displacement = NA
    n_displacement = NA
    horiz_displacement = NA
    avg_v_horiz = NA
    vertical_displacement = NA
    avg_v_h = NA
    total_displacement = NA
    avg_v_3d = NA
    horiz_azimuth = NA
    inclination = NA
    
    monthly_displacements2 <- rbind(monthly_displacements2, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
    lead_in_iterations <- lead_in_iterations - 1
  }
  
  lead_in_iterations <- 12 - as.numeric(avg_date_max_month)
  avg_date_max_year <- as.character(as.numeric(avg_date_max_year)-1)
  
  while (lead_in_iterations > 0) {
    avg_window_start_date_string <- avg_date_max_year&"-"&as.character(sprintf("%02d", lead_in_iterations+lead_in_month+1))&"-01"
    avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
    avg_window_stop_date <- avg_window_start_date
    month(avg_window_stop_date) <- month(avg_window_stop_date) + 1
    day(avg_window_stop_date) <- day(avg_window_stop_date) -1
    measurement_interval <- avg_window_start_date_string&"::"&as.character(avg_window_stop_date)
    e_displacement = NA
    n_displacement = NA
    horiz_displacement = NA
    avg_v_horiz = NA
    vertical_displacement = NA
    avg_v_h = NA
    total_displacement = NA
    avg_v_3d = NA
    horiz_azimuth = NA
    inclination = NA
    
    monthly_displacements2 <- rbind(monthly_displacements2, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
    lead_in_iterations <- lead_in_iterations - 1
  }
  
}


monthly_displacements2 <- rbind(monthly_displacements2, monthly_displacements)

avg_date_min_year  <- as.character(min(monthly_displacements$avg_window_start_date), tz="UTC", format="%Y")
avg_date_min_month <- as.character(min(monthly_displacements$avg_window_start_date), tz="UTC", format="%m")
avg_current_month = as.numeric(avg_date_min_month)

if (as.numeric(avg_date_min_month) > 9) {
  stop_month = 10
  avg_date_min_year = as.character(as.numeric(avg_date_min_year) + 1)
} else {
  stop_month = 1
}

while (avg_current_month > stop_month) {
  avg_window_start_date_string <- avg_date_min_year&"-"&as.character(sprintf("%02d", avg_current_month-1))&"-01"
  avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
  avg_window_stop_date <- avg_window_start_date
  month(avg_window_stop_date) <- month(avg_window_stop_date) + 1
  day(avg_window_stop_date) <- day(avg_window_stop_date) -1
  measurement_interval <- avg_window_start_date_string&"::"&as.character(avg_window_stop_date)
  e_displacement = NA
  n_displacement = NA
  horiz_displacement = NA
  avg_v_horiz = NA
  vertical_displacement = NA
  avg_v_h = NA
  total_displacement = NA
  avg_v_3d = NA
  horiz_azimuth = NA
  inclination = NA
  
  monthly_displacements2 <- rbind(monthly_displacements2, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
  avg_current_month <- avg_current_month - 1
}

if (as.numeric(avg_date_min_month) < 10) {
  avg_current_month = 13
  avg_date_min_hydr_year = as.character(as.numeric(avg_date_min_year) - 1)
  
  while (avg_current_month > 10) {
    avg_window_start_date_string <- avg_date_min_hydr_year&"-"&as.character(sprintf("%02d", avg_current_month-1))&"-01"
    avg_window_start_date <- as.POSIXct(avg_window_start_date_string, tz="UTC")
    avg_window_stop_date <- avg_window_start_date
    month(avg_window_stop_date) <- month(avg_window_stop_date) + 1
    day(avg_window_stop_date) <- day(avg_window_stop_date) -1
    measurement_interval <- avg_window_start_date_string&"::"&as.character(avg_window_stop_date)
    e_displacement = NA
    n_displacement = NA
    horiz_displacement = NA
    avg_v_horiz = NA
    vertical_displacement = NA
    avg_v_h = NA
    total_displacement = NA
    avg_v_3d = NA
    horiz_azimuth = NA
    inclination = NA
    
    monthly_displacements2 <- rbind(monthly_displacements2, data.frame(measurement_interval, avg_window_start_date, e_displacement, n_displacement, horiz_displacement, avg_v_horiz, vertical_displacement, avg_v_h, total_displacement, avg_v_3d, horiz_azimuth, inclination))
    avg_current_month <- avg_current_month - 1
  }
}


# ### Trial monthly levelplots
my.at = seq(as.numeric(avg_date_min_year), (as.numeric(avg_date_min_year)+length(monthly_displacements2$horiz_displacement)/12-1), by = 1)
if (length(my.at) > 5){
  my.scales=list(x=list(at=seq(1,length(my.at), by=2), labels=seq(as.numeric(avg_date_min_year), (as.numeric(avg_date_min_year)+length(monthly_displacements2$horiz_displacement)/12-1), by = 2)))
} else {
  my.scales=list(x=list(at=seq(1,length(my.at), by=1), labels=my.at))
  }

thedata <- matrix(rev(monthly_displacements2$horiz_displacement), nrow = 12, 
                  dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),my.at))
plot1 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", scales=my.scales, 
                   col.regions = heat.colors(200)[length(heat.colors(200)):1],
                   main=list(label="Horizontal Displacement [m/month]", cex=0.8))
thedata <- matrix(rev(monthly_displacements2$vertical_displacement), nrow = 12, 
                  dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),my.at))
plot2 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", scales=my.scales, 
                   col.regions = heat.colors(200)[1:length(heat.colors(200))], 
                   main=list(label="Vertial Displacement [m/month]", cex=0.8))
thedata <- matrix(rev(monthly_displacements2$total_displacement), nrow = 12, 
                  dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),my.at))
plot3 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", scales=my.scales, 
                   col.regions = heat.colors(200)[length(heat.colors(200)):1], 
                   main=list(label="3D Displacement [m/month]", cex=0.8))

thedata <- matrix(rev(monthly_displacements2$horiz_azimuth), nrow = 12, 
                  dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),my.at))
plot7 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", scales=my.scales, 
                  col.regions = heat.colors(200)[length(heat.colors(200)):1], 
                  main=list(label="Horizontal Displacement Azimuth", cex=0.8))
thedata <- matrix(rev(monthly_displacements2$inclination), nrow = 12, 
                  dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),my.at))
plot8 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", scales=my.scales, 
                  col.regions = heat.colors(200)[1:length(heat.colors(200))], 
                  main=list(label="Horizontal Displacement Inclination", cex=0.8))
plot9 <- xyplot(inclination~horiz_azimuth, data = monthly_displacements2, groups = NULL, xlim=c(0,360),
                ylab=list(label="Horizontal Displacement Inclination", cex=0.7), 
                xlab=list(label="Horizontal Displacement Azimuth", cex=0.7), 
                main=list(label="Displacement Inclination vs. Displacement Azimuth", cex=0.8), 
                type = "p", pch=15, col.symbol = terrain.colors(dim(thedata)[2]+1)
                , 
                auto.key=list(space="inside", x=0.05, y=0.975, col=terrain.colors(dim(thedata)[2]+1), 
                         lwd=2, text=as.character(my.at), points=FALSE, lines=FALSE, cex=0.8, border=TRUE)
#                auto.key=list("inside", text=c("mean","5th and 95th "), points=FALSE, lines=TRUE,col=terrain.colors(dim(thedata)[2]))
                )
                
#                legend(x=1, y=1, legend=c("me","my"), col=c(4,2))
#                )
#legend("topleft", legend=my.at)

if (!RTKLIB_processing) {
  thedata <- matrix(rev(monthly_displacements2$avg_v_horiz), nrow = 12, dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),as.numeric(avg_date_min_year):(as.numeric(avg_date_min_year)+length(monthly_displacements2$horiz_displacement)/12-1)))
  plot4 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", 
                     col.regions = heat.colors(200)[length(heat.colors(200)):1], 
                     main=list(label="Horizontal Velocity", cex=0.8))
  thedata <- matrix(rev(monthly_displacements2$avg_v_h), nrow = 12, dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),as.numeric(avg_date_min_year):(as.numeric(avg_date_min_year)+length(monthly_displacements2$horiz_displacement)/12-1)))
  plot5 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", 
                     col.regions = heat.colors(200)[1:length(heat.colors(200))], 
                     main=list(label="Vertical Velocity", cex=0.8))
  thedata <- matrix(rev(monthly_displacements2$avg_v_3d), nrow = 12, dimnames = list(c('10','11','12','1','2','3','4','5','6','7','8','9'),as.numeric(avg_date_min_year):(as.numeric(avg_date_min_year)+length(monthly_displacements2$horiz_displacement)/12-1)))
  plot6 <- levelplot(t(thedata[c(nrow(thedata):1) , ]), xlab = "", ylab = "", 
                     col.regions = heat.colors(200)[length(heat.colors(200)):1], 
                     main=list(label="3D Velocity", cex=0.8))
  
  grid.arrange(plot1,plot2,plot3,plot4,plot5,plot6,plot7,plot8,plot9, ncol=3, nrow=3)
} else {
  
  grid.arrange(plot1,plot2,plot3,plot7,plot8,plot9, ncol=3, nrow=2, top=textGrob(plot_title, gp=gpar(fontsize=18)), padding = unit(0.5, "line"))
}

#print plot to pdf
plot_name <- "gps_"&label&"_plot_levels.pdf"
dev.copy(pdf,plot_name, width=29.7/2.54, height=21/2.54)
dev.off()


##==================================================================
## Getting Inclinometer data
##==================================================================
try(source('../r_toolchain/permasense_inclinometer_exporter.R'))

# Plot GPS and Inclinometer Data
############################################################################################################
par(mfrow=c(5,1), mar=c(2,4,3,1), oma=c(2,1,4,1)) #bottom, left, top, right
plot_title <- as.character(label&" - Position "&position&" - "&as.Date(min(get("gps_data_"&label)$generation_time))&" to "&as.Date(max(get("gps_data_"&label)$generation_time)))

plot(get("gps_data_"&label)$generation_time,get("gps_data_"&label)$e,type="p", col="blue", cex=0.2, main="Displacement East", ylab="East", xlab="")
legend("bottomleft", inset=0.05, lty=1, #cex=0.6,
       legend=c("Total east displacement: "&east_displacement&" m\n",
                "Average east displacement rate: "&east_rate&" m/a\n"))
i=dim(inclinometer_device_changes)[1]
while (i > 0){
  abline(v=inclinometer_device_changes[i,1], lty=3, col="grey")
  abline(v=inclinometer_device_changes[i,2], lty=3, col="grey")
  i = i -1
}
abline(v=max(get("gps_data_"&label)$generation_time)-365*3600*24, lty=3)

plot(get("gps_data_"&label)$generation_time,get("gps_data_"&label)$n,type="p", col="blue", cex=0.2, main="Displacement North", ylab="North", xlab="")
legend("topleft", inset=0.05, lty=1, #cex=0.6,
       legend=c("Total north displacement: "&north_displacement&" m\n",
                "Average north displacement rate: "&north_rate&" m/a\n"))
i=dim(inclinometer_device_changes)[1]
while (i > 0){
  abline(v=inclinometer_device_changes[i,1], lty=3, col="grey")
  abline(v=inclinometer_device_changes[i,2], lty=3, col="grey")
  i = i -1
}
abline(v=max(get("gps_data_"&label)$generation_time)-365*3600*24, lty=3)

plot(get("gps_data_"&label)$generation_time,get("gps_data_"&label)$h,type="p", col="blue", cex=0.2, main="Displacement Altitude", ylab="Altitude [m]", xlab="")
legend("bottomleft", inset=0.05, lty=1, #cex=0.6,
       legend=c("Total vertical displacement: "&vertical_displacement&" m\n",
                "Average vertical displacement rate: "&vertical_rate&" m/a\n",
                "Total displacement: "&total_displacement&" m\n",
                "Average total displacement rate: "&total_rate&" m/a\n"))
i=dim(inclinometer_device_changes)[1]
while (i > 0){
  abline(v=inclinometer_device_changes[i,1], lty=3, col="grey")
  abline(v=inclinometer_device_changes[i,2], lty=3, col="grey")
  i = i -1
}
abline(v=max(get("gps_data_"&label)$generation_time)-365*3600*24, lty=3)

#plot(get("gps_monthly_displacements_"&label)$avg_window_start_date, 1/get("gps_monthly_displacements_"&label)$total_displacement,type="p", col="blue", cex=0.2, main="Displacement Altitude", ylab="1/displacement", xlab="")
#abline(v=0, lty=3)
#legend("bottomleft", inset=0.05, lty=1, #cex=0.6,
#       legend=c("Total vertical displacement: "&vertical_displacement&" m\n",
#                "Average vertical displacement rate: "&vertical_rate&" m/a\n",
#                "Total displacement: "&total_displacement&" m\n",
#                "Average total displacement rate: "&total_rate&" m/a\n"))

plot(get("inclinometer_downsampled_data_"&label)$generation_time, get("inclinometer_downsampled_data_"&label)$inclinometer_x, main="Inclinometer X", type="p", pch=20, col="blue", ylab="[deg]")
abline(h=0, lty=3)
i=dim(inclinometer_device_changes)[1]
while (i > 0){
  abline(v=inclinometer_device_changes[i,1], lty=3, col="grey")
  abline(v=inclinometer_device_changes[i,2], lty=3, col="grey")
  i = i -1
}
abline(v=max(get("inclinometer_downsampled_data_"&label)$generation_time)-365*3600*24, lty=3)
legend("topleft", inset=0.05, legend=c("Thin vertical bars denote device changes, thick vertical bars indicate -1Y"), cex=1)

plot(get("inclinometer_downsampled_data_"&label)$generation_time, get("inclinometer_downsampled_data_"&label)$inclinometer_y, main="Inclinometer Y", type="p", pch=20, col="blue", ylab="[deg]")
abline(h=0, lty=3)
i=dim(inclinometer_device_changes)[1]
while (i > 0){
  abline(v=inclinometer_device_changes[i,1], lty=3, col="grey")
  abline(v=inclinometer_device_changes[i,2], lty=3, col="grey")
  i = i -1
}
abline(v=max(get("inclinometer_downsampled_data_"&label)$generation_time)-365*3600*24, lty=3)

mtext(plot_title, outer = TRUE, cex = 1.5)

dev.copy(pdf,"gps_"&label&"_plot_inclinometer.pdf", width=21/2.54, height=29.7/2.54)
dev.off()


print("Done. Go have an ice cream...")

